Bug 883512 - (libforensic1394) Review Request: libforensic1394 - A library for performing live memory forensics over firewire
Review Request: libforensic1394 - A library for performing live memory forens...
Status: CLOSED CURRENTRELEASE
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Eduardo Echeverria
Fedora Extras Quality Assurance
:
Depends On:
Blocks: FE-SECLAB inception
  Show dependency treegraph
 
Reported: 2012-12-04 13:44 EST by Fabian Affolter
Modified: 2014-09-11 15:33 EDT (History)
4 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2013-01-28 10:11:26 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
echevemaster: fedora‑review+
limburgher: fedora‑cvs+


Attachments (Terms of Use)
Alternate spec (3.30 KB, text/x-rpm-spec)
2012-12-31 00:48 EST, Eduardo Echeverria
no flags Details

  None (edit)
Description Fabian Affolter 2012-12-04 13:44:42 EST
Spec URL: http://fab.fedorapeople.org/packages/SRPMS/libforensic1394.spec
SRPM URL: http://fab.fedorapeople.org/packages/SRPMS/libforensic1394-0.2-1.fc17.src.rpm

Project URL: https://freddie.witherden.org/tools/libforensic1394/

Description:
An library for performing live memory forensics over the IEEE 1394 (FireWire)
interface. libforensic1394 improves upon existing libraries by providing a
simple and clean interface to the the direct memory access functionality
available over FireWire.

Koji scratch build:
http://koji.fedoraproject.org/koji/taskinfo?taskID=4756688

rpmlint output:
libforensic1394.src: W: spelling-error Summary(en_US) firewire -> fire wire, fire-wire, firewater
1 packages and 0 specfiles checked; 0 errors, 1 warnings.

[fab@laptop11 x86_64]$ rpmlint libforensic1394* python-forensic1394*
libforensic1394.x86_64: W: spelling-error Summary(en_US) firewire -> fire wire, fire-wire, firewater
4 packages and 0 specfiles checked; 0 errors, 1 warnings.

Fedora Account System Username: fab
Comment 1 Eduardo Echeverria 2012-12-09 15:54:25 EST
Hi Fabian: 
- In the devel subpackage %{name} = %{version}-%{release} has to be %{name}%{?_isa} = %{version}-%{release} to match the correct architecture
- The python bindings subpackage should be renamed to python3-forensic1394.
- in the README can be read

"Python language  bindings are provided in the  python/ directory and
are  compatible with  all versions  of Python  since  2.5 (including
Python 3)"

so it should provide a subpackage built with python2-devel in addition to the existing python3 bindings 

- although the subpackage devel included documentation and not the main one. there's a lot of documentation, (358400 bytes in 49 files),  IMO I consider should be putting it into a -doc subpackage.

- The "Provides" of python bindings subpackage, it is not picked up automatically while building the package
Comment 2 Michael Schwendt 2012-12-10 09:56:36 EST
> there's a lot of documentation, (358400 bytes in 49 files)

Where does "a lot" start for you? ;)

358KB for a -devel subpackage is a joke. The resulting -devel package for x86_64 is just around 8 KiB!

It gets less funny size-wise when the documentation adds 2MB or 3MB to the size of the RPM package, or hundreds of files, but only if too many -devel packages do this (as that increases the time it takes to populate the buildroot).

[...]

Anyway, it's good to mention the related guidelines, but IMO you should be more explicit about why you recommend a -doc package. Neither 385400 bytes nor 49 files sounds convincing to a packager, who's not a packaging newbie.
https://fedoraproject.org/wiki/Packaging:Guidelines#Documentation

The ReviewGuidelines say:

| MUST: Large documentation files must go in a -doc subpackage.
| (The definition of large is left up to the packager's best judgement,
| but is not restricted to size. Large can refer to either size or quantity). 

[...]

> %files
> %doc AUTHORS COPYING COPYING.LESSER README

> %files devel
> %doc COPYING COPYING.LESSER docs/docs/html

>%files -n python-%{s_name}
> %doc COPYING COPYING.LESSER

The following applies:
https://fedoraproject.org/wiki/Packaging:LicensingGuidelines#Subpackage_Licensing
Comment 3 Michael Schwendt 2012-12-10 09:59:29 EST
Oh, and test-build and src.rpm don't match. Test-build places the docs in the base package, which ends up with a size of just 91 KB, which isn't anything like "large" either. The src.rpm and spec file seem to be newer.
Comment 4 Eduardo Echeverria 2012-12-10 20:58:44 EST
(In reply to comment #2)
> > there's a lot of documentation, (358400 bytes in 49 files)
> 
> Where does "a lot" start for you? ;)
> 
> 358KB for a -devel subpackage is a joke. The resulting -devel package for
> x86_64 is just around 8 KiB!

> The ReviewGuidelines say:
> 
> | MUST: Large documentation files must go in a -doc subpackage.
> | (The definition of large is left up to the packager's best judgement,
> | but is not restricted to size. Large can refer to either size or
> quantity). 

Hi Michael
I admit your point of view in this case and I really appreciate your explanation, I remain as experience for future reviews
Comment 5 Fabian Affolter 2012-12-17 16:46:46 EST
(In reply to comment #1)
> - In the devel subpackage %{name} = %{version}-%{release} has to be
> %{name}%{?_isa} = %{version}-%{release} to match the correct architecture

Fixed

> - The python bindings subpackage should be renamed to python3-forensic1394.
> - in the README can be read

Changed

> "Python language  bindings are provided in the  python/ directory and
> are  compatible with  all versions  of Python  since  2.5 (including
> Python 3)"
> so it should provide a subpackage built with python2-devel in addition to
> the existing python3 bindings

Python2 subpackage added
 
> - although the subpackage devel included documentation and not the main one.
> there's a lot of documentation, (358400 bytes in 49 files),  IMO I consider
> should be putting it into a -doc subpackage.
> 
> - The "Provides" of python bindings subpackage, it is not picked up
> automatically while building the package

Fixed

(In reply to comment #2)
> > %files
> > %doc AUTHORS COPYING COPYING.LESSER README
> 
> > %files devel
> > %doc COPYING COPYING.LESSER docs/docs/html
> 
> >%files -n python-%{s_name}
> > %doc COPYING COPYING.LESSER

fixed

Koji scratch build:
http://koji.fedoraproject.org/koji/taskinfo?taskID=4798095

rpmlint output:
[fab@laptop11 SRPMS]$ rpmlint libforensic1394-0.2-2.fc17.src.rpm 
libforensic1394.src: W: spelling-error Summary(en_US) firewire -> fire wire, fire-wire, firewater
1 packages and 0 specfiles checked; 0 errors, 1 warnings.

[fab@laptop11 x86_64]$ rpmlint *forensic*
libforensic1394.x86_64: W: spelling-error Summary(en_US) firewire -> fire wire, fire-wire, firewater
python2-forensic1394.x86_64: W: no-documentation
python3-forensic1394.x86_64: W: no-documentation
5 packages and 0 specfiles checked; 0 errors, 3 warnings.

%changelog
* Mon Dec 10 2012 Fabian Affolter <mail@fabian-affolter.ch> - 0.2-2
- python2 package added
- -devel subpackage requires: fixed
- License files from the subpackages removed
- python 3 subpackage renamed
- Docs generation changed

Updated files:
Spec URL: http://fab.fedorapeople.org/packages/SRPMS/libforensic1394.spec
SRPM URL: http://fab.fedorapeople.org/packages/SRPMS/libforensic1394-0.2-2.fc17.src.rpm
Comment 6 Eduardo Echeverria 2012-12-17 22:02:25 EST
Hi Fabian:
Please take a copy of the sources of the python bindings during the %prep phase, and configure one subdirectory to build against python 2, another to build against python 3
http://fedoraproject.org/wiki/Packaging:Python#Common_SRPM_vs_split_SRPMs
Comment 7 Eduardo Echeverria 2012-12-31 00:48:13 EST
Created attachment 670684 [details]
Alternate spec
Comment 8 Eduardo Echeverria 2012-12-31 00:49:09 EST
Hi Fabian 
I've done a alternate spec maybe that give you some hints to build the python bindings. I hope I've helped. btw  Happy New Year 2013 !
Comment 9 Fabian Affolter 2013-01-05 15:42:18 EST
Happy new 2013 to you too. Thanks for the patch.

Updated files:
Spec URL: http://fab.fedorapeople.org/packages/SRPMS/libforensic1394.spec
SRPM URL: http://fab.fedorapeople.org/packages/SRPMS/libforensic1394-0.2-3.fc17.src.rpm
Comment 10 Eduardo Echeverria 2013-01-05 21:59:17 EST
Hi Fabian, you're welcome

Now I'll do the formal review: 

- The warnings about the spelling errors can be ignored

Package Review
==============

Key:
[x] = Pass
[!] = Fail
[-] = Not applicable
[?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

C/C++:
[x]: Header files in -devel subpackage, if present.
[x]: ldconfig called in %post and %postun if required.
[x]: Package does not contain any libtool archives (.la)
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Rpath absent or only used for internal libs.
[x]: Development (unversioned) .so files in -devel subpackage, if present.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.

Koji Build: http://koji.fedoraproject.org/koji/taskinfo?taskID=4843213
Koji PPC:  http://ppc.koji.fedoraproject.org/koji/taskinfo?taskID=849455
Koji S390: http://s390.koji.fedoraproject.org/koji/taskinfo?taskID=907689
Koji ARM:  http://arm.koji.fedoraproject.org/koji/taskinfo?taskID=1351806


[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package contains no bundled libraries.
[x]: Changelog in prescribed format.
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Sources contain only permissible code or content.
[x]: Each %files section contains %defattr if rpm < 4.4
[x]: Macros in Summary, %description expandable at SRPM build time.
[-]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package requires other packages for directories it uses.
[x]: Package uses nothing in %doc for runtime.
[x]: Package is not known to require ExcludeArch.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Fully versioned dependency in subpackages, if present.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in %package -n
     python2-%{s_name}, %package devel, %package -n python3-%{s_name}
[x]: Package complies to the Packaging Guidelines
[x]: Spec file lacks Packager, Vendor, PreReq tags.
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "LGPL (v3 or later)", "Unknown or generated". 2 files have unknown
     license. Detailed output of licensecheck in
     /home/makerpm/libforensics05012013/883512-libforensic1394/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[x]: Package consistently uses macro is (instead of hard-coded directory
     names).
[x]: Package is named using only allowed ASCII characters.
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
     Note: Package contains no Conflicts: tag(s)
[x]: Package do not use a name that already exist
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package installs properly.
[x]: Package is not relocatable.
[x]: Requires correct, justified where necessary.
[x]: CheckResultdir
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file is legible and written in American English.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[-]: Package contains systemd file(s) if in need.
[x]: File names are valid UTF-8.
[x]: Useful -debuginfo package or justification otherwise.
[-]: Large documentation must go in a -doc subpackage.
     Note: Documentation size is 583680 bytes in 92 files.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[x]: Package contains BR: python2-devel or python3-devel
[x]: Binary eggs must be removed in %prep
[x]: Python eggs must not download any dependencies during the build process.
[x]: A package which is used by another package via an egg interface should
     provide egg info.
[x]: Package meets the Packaging Guidelines::Python

===== SHOULD items =====

Generic:
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Dist tag is present.
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Final provides and requires are sane (rpm -q --provides and rpm -q
     --requires).
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Patches link to upstream bugs/comments/lists or are otherwise justified.
[x]: The placement of pkgconfig(.pc) files are correct.
[x]: Scriptlets must be sane, if used.
[x]: SourceX tarball generation or download is documented.
[x]: SourceX / PatchY prefixed with %{name}.
[x]: SourceX is a working URL.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Spec use %global instead of %define.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.
[x]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.


Rpmlint
-------
Checking: libforensic1394-0.2-3.fc17.src.rpm
          libforensic1394-0.2-3.fc17.x86_64.rpm
          libforensic1394-devel-0.2-3.fc17.x86_64.rpm
          libforensic1394-debuginfo-0.2-3.fc17.x86_64.rpm
libforensic1394.src: W: spelling-error Summary(en_US) firewire -> fire wire, fire-wire, firewater
libforensic1394.x86_64: W: spelling-error Summary(en_US) firewire -> fire wire, fire-wire, firewater
4 packages and 0 specfiles checked; 0 errors, 2 warnings.




Rpmlint (installed packages)
----------------------------
# rpmlint libforensic1394-debuginfo libforensic1394-devel l 
ibforensic1394
libforensic1394.x86_64: W: spelling-error Summary(en_US) firewire -> fire wire, fire-wire, firewater
3 packages and 0 specfiles checked; 0 errors, 1 warnings.
# echo 'rpmlint-done:'



Requires
--------
libforensic1394-0.2-3.fc17.x86_64.rpm (rpmlib, GLIBC filtered):
    
    /sbin/ldconfig
    libc.so.6()(64bit)
    rtld(GNU_HASH)

libforensic1394-devel-0.2-3.fc17.x86_64.rpm (rpmlib, GLIBC filtered):
    
    libforensic1394(x86-64) = 0.2-3.fc17
    libforensic1394.so.1()(64bit)

libforensic1394-debuginfo-0.2-3.fc17.x86_64.rpm (rpmlib, GLIBC filtered):
    



Provides
--------
libforensic1394-0.2-3.fc17.x86_64.rpm:
    
    libforensic1394 = 0.2-3.fc17
    libforensic1394(x86-64) = 0.2-3.fc17
    libforensic1394.so.1()(64bit)

libforensic1394-devel-0.2-3.fc17.x86_64.rpm:
    
    libforensic1394-devel = 0.2-3.fc17
    libforensic1394-devel(x86-64) = 0.2-3.fc17

libforensic1394-debuginfo-0.2-3.fc17.x86_64.rpm:
    
    libforensic1394-debuginfo = 0.2-3.fc17
    libforensic1394-debuginfo(x86-64) = 0.2-3.fc17



MD5-sum check
-------------
https://freddie.witherden.org/tools/libforensic1394/releases/libforensic1394-0.2.tar.gz :
  CHECKSUM(SHA256) this package     : 50a82fe2899aa901104055da2ac00b4c438cf1d0d991f5ec1215d4658414652e
  CHECKSUM(SHA256) upstream package : 50a82fe2899aa901104055da2ac00b4c438cf1d0d991f5ec1215d4658414652e

I don't see anymore blockers, therefore

----------------

PACKAGE APPROVED

----------------
Comment 11 Fabian Affolter 2013-01-06 11:50:02 EST
Thnaks for the review, Eduardo.
Comment 12 Fabian Affolter 2013-01-06 11:53:23 EST
Can you please re-set the review flag? I took the wrong one flag and saved it. Sorry.
Comment 13 Fabian Affolter 2013-01-06 15:15:02 EST
New Package SCM Request
=======================
Package Name: libforensic1394
Short Description: A library for performing live memory forensics over firewire
Owners: fab
Branches: F17 F18
InitialCC:
Comment 14 Jon Ciesla 2013-01-07 08:28:06 EST
Git done (by process-git-requests).
Comment 15 Fedora Update System 2013-01-07 14:22:00 EST
libforensic1394-0.2-3.fc17 has been submitted as an update for Fedora 17.
https://admin.fedoraproject.org/updates/libforensic1394-0.2-3.fc17
Comment 16 Fedora Update System 2013-01-07 14:22:13 EST
libforensic1394-0.2-3.fc18 has been submitted as an update for Fedora 18.
https://admin.fedoraproject.org/updates/libforensic1394-0.2-3.fc18
Comment 17 Fedora Update System 2013-01-08 15:16:27 EST
libforensic1394-0.2-3.fc18 has been pushed to the Fedora 18 testing repository.
Comment 18 Fedora Update System 2013-01-08 17:56:06 EST
libforensic1394-0.2-4.fc17 has been submitted as an update for Fedora 17.
https://admin.fedoraproject.org/updates/libforensic1394-0.2-4.fc17
Comment 19 Fedora Update System 2013-01-08 17:56:23 EST
libforensic1394-0.2-4.fc18 has been submitted as an update for Fedora 18.
https://admin.fedoraproject.org/updates/libforensic1394-0.2-4.fc18
Comment 20 Fedora Update System 2013-01-15 13:41:44 EST
libforensic1394-0.2-5.fc18 has been submitted as an update for Fedora 18.
https://admin.fedoraproject.org/updates/libforensic1394-0.2-5.fc18
Comment 21 Fedora Update System 2013-01-15 13:42:03 EST
libforensic1394-0.2-5.fc17 has been submitted as an update for Fedora 17.
https://admin.fedoraproject.org/updates/libforensic1394-0.2-5.fc17
Comment 22 Fedora Update System 2013-01-28 10:11:30 EST
libforensic1394-0.2-5.fc18 has been pushed to the Fedora 18 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 23 Fedora Update System 2013-01-28 10:16:57 EST
libforensic1394-0.2-5.fc17 has been pushed to the Fedora 17 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 24 Fabian Affolter 2014-09-11 15:10:03 EDT
Package Change Request
======================
Package Name: libforensic1394
New Branches: epel7
Owners: fab 
InitialCC:
Comment 25 Jon Ciesla 2014-09-11 15:33:08 EDT
Git done (by process-git-requests).

Note You need to log in before you can comment on or make changes to this bug.